require 'active_support/time'
require 'off_the_grid_trucks/request'
require 'off_the_grid_trucks/event'
require 'off_the_grid_trucks/location'
require 'off_the_grid_trucks/service'

module OffTheGridTrucks
  class DetailedEvent < Event
    attr_reader :meal_type, :location, :location_details, :services,
                :community_activations, :entertainments

    def initialize(args)
      super(args)

      @meal_type = args.fetch('mealType') {}
      @location = Location.new(args.fetch('location') {})
      @location_details = args.fetch('locationDetails') {}
      @services = args.fetch('services') {}.map { |service| Service.new(service) }
      @community_activations = args.fetch('communityActivations') {}
      @entertainments = args.fetch('entertainments') {}
    end

    class << self
      def all; end

      def get(id)
        new(Request.get(resource: 'events', id: id)['event'])
      end
    end
  end
end
