require 'active_support/time'
require 'off_the_grid_trucks/request'

module OffTheGridTrucks
  class Event
    attr_reader :id, :name, :start_time, :end_time, :location_id, :location_name,
                :assigned_vendors, :number_of_assigned_vendors, :is_featured

    def initialize(args)
      @id = args.fetch('id') {}
      @name = args.fetch('name') {}
      @start_time = args.fetch('startTime') {}
      @end_time = args.fetch('endTime') {}
      @location_id = args.fetch('locationId') {}
      @location_name = args.fetch('locationName') {}
      @assigned_vendors = args.fetch('assignedVendors') {}
      @number_of_assigned_vendors = args.fetch('numberOfAssignedVendors') {}
      @is_featured = args.fetch('isFeatured') {}
    end

    class << self
      def all(from_date: 0, to_date: Time.now)
        query = {
          dateFrom: date_to_seconds(from_date),
          dateTo: date_to_seconds(to_date)
        }
        Request.get(
          resource: 'events',
          query: query
        )['events'].map { |event| new(event) }
      end

      private

      def date_to_seconds(date)
        date.to_i.to_s.ljust(13, '0').to_i
      end
    end
  end
end
